/*-------------------------------------------------------------------------*/
/* Benchmark (Finite Domain)                                               */
/*                                                                         */
/* Name           : magsq.pl                                               */
/* Title          : Magic square problem                                   */
/* Original Source: Daniel Diaz - INRIA France                             */
/* Adapted by     : Daniel Diaz for GNU Prolog                             */
/* Date           : July 1998                                              */
/*                                                                         */
/* Fill square NxN with integers 1,2...N*N so that each line, each column  */
/* and each diagonal has the same sum.                                     */
/* threatening each other.                                                 */
/*                                                                         */
/* Solution:                                                               */
/* N=3  [[4,9,2],[3,5,7],[8,1,6]]                                          */
/*-------------------------------------------------------------------------*/


magsq(N,A):-
%	Sym=[],
%	Sym=[ms4_1,ms4_2,ms4_3,vert_arr,hor_arr],
	Sym=[hor_arr,vert_arr,diag1_arr,diag2_arr],
%	Sym=[hor_arr,vert_arr,diag1_arr,diag2_arr,rot90_arr,rot180_arr,rot270_arr],
%	gen_group(cm4,Sym),
	create_array(N,N,A),
	N2 is N*N,
	fd_set_vector_max(N2),
	S is N*(N2+1) // 2,
	g_assign(s,S),
	g_assign(n,N),
	g_assign(n2,N2),

        array_values(A,Values),
	fd_all_different(Values),

	for_each_line(A,dom),

	for_each_line(A,sum),
	for_each_column(A,sum),
	for_each_big_diagonal(A,N,sum),

%	array_elem(A,1,4,X14),
%	array_elem(A,1,1,X11),
%	array_elem(A,4,1,X41),
%	array_elem(A,4,4,X44),
	
%	X11 #< X14,
%	X11 #< X41,
%	X11 #< X44,
%	X14 #> X41,

%	Order=[6,7,13,10,1,2,3,4,5,8,9,11,12,14,15,16],
	Order=standard,
%	fd_labeling(Values,[value_method(middle),variable_method(first_fail)]).
	labeling_sbds(Values,Sym,[N],[var_order(Order),val_order(middle)]).
%	labeling_sbds(Values,Sym,[N],[]).




array_prog(dom,L):-
	g_read(n2,N2),
	fd_domain(L,1,N2).

array_prog(sum,L):-
	g_read(s,S),
	sum(L,S).

array_prog(lab,L):-
	fd_labeling(L,[value_method(middle)]).


/*
reorder(L,L1):-
	g_read(n,N),
	fd_domain(X,1,N),
	findall(V,(fd_labeling(X,[value_method(middle)]),nth(X,L,V)),L1).
*/



sum([],0).

sum([X|Xs],S):-
        S #= X+S1,
        sum(Xs,S1).

