% Social Golfer problem
% http://4c.ucc.ie/~tw/csplib//prob/prob010/index.html
% Copyright (C) 2003 INRIA Sylvain Soliman

% file sco_golf.pl
% January 14 2003: Version 0.0.1

golf(G,S,W,R) :-     % G groups of S golfers play for W weeks
   M is G*S,
   init_max_list(M,MaxList),
   length(R,W),      % R, the result, is a list of weeks, each being a list...
   init_weeks(MaxList,S,R,[],GroupList),
   no_two_common(GroupList).

init_max_list(1,[1]).
init_max_list(N,[N|L]) :-
   N > 1,
   M is N-1,
   init_max_list(M,L).
   
init_weeks(_,_,[],GL,GL).
init_weeks(ML,S,[GL|WL],GL1,GL2) :-
   permut(Week,ML),
   init_groups(Week,S,GL),
   append(GL,GL1,GL3),
   init_weeks(ML,S,WL,GL3,GL2).

init_groups([],_,[]).

init_groups(Week,S,[L|GL]) :-
   length(L,S),
   append(L,R,Week),
   init_groups(R,S,GL).

no_two_common([]).
no_two_common([H|T]) :-
   no_two_common(H,T),
   no_two_common(T).

no_two_common(_,[]).
no_two_common(L,[H|T]) :-
   no_two_common(L,H,0),
   no_two_common(L,T).

no_two_common([],_,_).
no_two_common([H|T],L,N) :-
   member(H,L) ->
   (N == 0,
    no_two_common(T,L,1));
   (no_two_common(T,L,N)).

permut([],[]).
permut([H|T],L) :-
   select(H,L,R),
   permut(T,R).
